package MyLib::Eng;

use strict;
use base 'CGI::Application';
use CGI::Application::Plugin::DBH (qw(dbh_config dbh));
use CGI::Application::Plugin::ConfigAuto (qw(cfg cfg_file));
use CGI::Application::Plugin::Session;
use CGI::Application::Plugin::Forward;
use Data::Dumper;

# ------------------------------------------------------------------------------
# run mode
# ------------------------------------------------------------------------------
sub setup {
    my $self = shift;
    $self->start_mode('input'); # ǥեȤΥ⡼
    $self->error_mode('error'); # 顼ڡ
    $self->mode_param('rm');

    # run mode̾ => ؿ̾ бդ
    # ƱˤƤʬפƤ褤
    $self->run_modes(
        'input' => 'input',
        'check' => 'check',
        'finish' => 'finish',
    );
    
    $self->header_add( -type => 'text/html; charset=euc-jp' );
}

#########################
# Session
#########################
sub cgiapp_init {
	my $self = shift;
	
	$self->session_config(
		CGI_SESSION_OPTIONS => [ "driver:File", $self->query, {Directory=>'./tmp'} ],
		DEFAULT_EXPIRY      => '+60s',
		COOKIE_PARAMS       => {
								-path  => '/',
								},
		SEND_COOKIE         => 1,
		);
	
	$self->session_cookie(-name => 'testcookie', -expires => '+30s');
}

# ------------------------------------------------------------------------------
# run mode¹Ԥ˼¹Ԥ롣
# ƼѿνDB³򤷤ƤȤ褤
# ------------------------------------------------------------------------------
sub cgiapp_prerun {
    my $self = shift;
    # ƥץ졼ȥեΤѥ
    $self->tmpl_path($self->cfg('template_dir'));
}

# ------------------------------------------------------------------------------
# 顼Τ
# ------------------------------------------------------------------------------
sub error {
    my $self = shift;
    my $error = shift;
    # $error"ե뤬ץǤޤ"ߤʡPerl(OS)֤ƥ
    # 顼åäƤ
    # 桼ΤʤϡʤȤ
    return "ƥ२顼ޤ $error";
}

#
# ʹߡrun modeбƼ¹Ԥؿ
#

# ------------------------------------------------------------------------------
# ϼղ
# ------------------------------------------------------------------------------
sub input {
    my $self = shift;
    my $errs = shift;
    my $q = $self->query();

    # ϥǡʳǧ̤äƤΥڡƤ
    my %input;
    foreach (qw(name age mail)){
        # $input{$_} = $self->_escape_html($q->param($_));
        $input{$_} = $self->session->param($_);
    }
	
	# SessionID
	$input{'SID'} = $self->session->id();
	
    # ƥץ졼Ȥν
    my $template = $self->load_tmpl('input.tmpl');
    foreach (qw(name age mail SID)){
        $template->param($_,$input{$_});
    }

    # ϥǡ˥顼äơᤵƤβ̤礬롣
    # ξˤϡ$errsåȤƤ롣
    # $errsȤϡ
    # { err_name => 'ϤƤޤ',
    #   err_age  => 'ϤƤ' }
    # Τ褦ʥϥåե󥹤ˤʤäƤäơƥץ졼ȤˤΤޤϤ
    # 롣
    $template->param($errs) if $errs;
	
	# β̤ǤϤޤϤǧڤƤʤΤSessionȤ϶
	$self->session->param('name', '');
	$self->session->param('age', '');
	$self->session->param('mail', '');
	$self->session->param('checked', '');
	
    # ɽHTMLCGI::AppliationϤ
    return $template->output();
}

# ------------------------------------------------------------------------------
# ϥǡǧ
# ------------------------------------------------------------------------------
sub check {
    my $self = shift;

    # ϥǡ
    my $q = $self->query();
    my %input;
    foreach (qw(name age mail)){
        $input{$_} = $self->_escape_html($q->param($_));
    }

    use CGI::Application::Plugin::ValidateRM (qw(check_rm));
    my ($results,$err_page) = $self->check_rm('input','_validate');
    
    if ($err_page)
    {
    	# եåΥ顼
    	
    	# SessionΥåѤߤΥޡȤ
    	$self->session->param('checked', '');
    	
    	return $err_page;
    }

    # ƥץ졼Ȥν
    my $template = $self->load_tmpl('check.tmpl');
    foreach (qw(name age mail)){
        $template->param($_,$input{$_});
        $self->session->param($_, $input{$_});		# Sessionˤ
    }
	
	# Session˥åѤߤΥޡ
	$self->session->param('checked', 'true');
	
	# SessionID
	$template->param('SID', $self->session->id());
	
    # ɽHTMLCGI::AppliationϤ
    return $template->output();
}

# ------------------------------------------------------------------------------
# Ͽλβ
# ------------------------------------------------------------------------------
sub finish {
    my $self = shift;

    # ϥǡ
    # HIDDENƤƤϥ
    my $q = $self->query();
    my %input;
    foreach (qw(name age mail checked)){
        # $input{$_} = $self->_escape_html($q->param($_));
        $input{$_} = $self->session->param($_);
    }
	
	# Sessionڤθ
	if ($input{'checked'} eq '')
	{
		return $self->forward('input');
	}
	
    #
    # 衢ϥǡե˽񤭹ʤꡢDBʤꡢ롣
    #

    # ƥץ졼Ȥν
    my $template = $self->load_tmpl('finish.tmpl');
    $template->param('name',$input{name});
	
	# SessionID
	$template->param('SID', $self->session->id());
	
	# Session˴
	$self->session->delete();
	
    # ɽHTMLCGI::AppliationϤ
    return $template->output();
}

#
# ʹߡǻȤؿؿ̾Ƭ_Ĥơץ饤١ȴؿäݤȤ褤
# DB򰷤ؿäꤷơrun modeδؿƤӽФ褦ˤơȤ
#

#------------------------------------------------------------------------------
# HTML
#------------------------------------------------------------------------------
sub _escape_html {
    my ($self,$str) = @_;
    $str =~ s/&/&amp;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/"/&quot;/g;
    return $str;
}

sub _validate {

    # ܤϡʲΥɥȤ
    # http://search.cpan.org/~markstos/Data-FormValidator-4.01/lib/Data/FormValidator.pm

    my $self = shift;
    return {
        # required:ɬ optional: ʤƤ褤
        # ɤˤꤷƤʤСʸνϤä̵뤵褦
        required    => [qw(name age)],
        optional    => [qw(mail)],

        # ϥǡ˥ե륿򤫤
        # trimϡPHPtrim()ߤʤΤǡΥڡƤ롣
        # ǡɬܥåʤɤ򤹤롣Τǡڡ1Ĥ̾ʤɤ
        # NG
        filters     => ['trim'],

        # 
        constraints => {
                # <input name="mail">ͤå
                # emailϥǥեȤΥ᡼åʤǤ⡢ޤ긷̩
                # 褦
                mail    => 'email',
                # ɽ󤬽񤱤
                age     => qr/^\d{1,2}$/,
                # ʣ
                name    => [
                    {
                        constraint  => qr/^.{1,10}/,
                    },
                    # nameꤷƤȤǡǥ२顼å
                    {
                        name        => 'reserved_name',
                        constraint  => sub {
                            my $name = shift;
                            return 1 if $name ne 'root';
                        },
                        # constraint̵̾ؿϤ
                        params      => [qw(name)],
                    },
                ],
        },

        # 顼åꤹ
        msgs        => {
            # invalidǥեȤΥ顼ˤʤΤǡ餷ʸˤ
            invalid     => 'ϤǤ',
            missing     => 'Ϥޤ',

            # 饨顼äϡѿ˥ե饰ΩƤƤȡ桼
            # ΤȤ
            any_errors  => 'some_errors',

            # ץեåꤷƤȤǡƥץ졼ȥե
            # <TMPL_VAE name=err_name> Τ褦ˤƻꤹ뤳Ȥˤʤ롣
            # ʤȤ褤ξ硢<TMPL_VAE name=_name>Ȥʤ롣
            prefix      => 'err_',

            # printf()ηǥ顼å
            format      => '<span style="color:red; font-weight:bold">%s</span>',

            # ˤ碌åꤹ
            constraints => {
                'reserved_name' => '̾ϻѤǤޤ',
            },
        }
    };
}

1;


